<script lang="ts">
  import type { ActiveChallenge, ChallengeFile } from '@models/Challenges';
  import { Alert, Button, Input, InputGroup, Modal, ModalBody } from 'sveltestrap';
  import SvelteMarkdown from 'svelte-markdown';
  import Code from '@components/Utils/Code.svelte';
  import CodeSpan from '@components/Utils/CodeSpan.svelte';
  import { SubmitFlag } from '@models/Challenges';
  import type { Team } from '@models/Team';
  import type { NullableEventRole } from '@auth/models';
  import type { Color } from 'sveltestrap/src/shared';
  import ChallengeFileDownload from '@components/Challenges/ChallengeFileDownload.svelte';
  import type { KeycloakInterface } from '@auth/keycloak';
  import { KeycloakStore } from '@auth/keycloak';

  export let challenge: ActiveChallenge;
  export let team: Team;
  export let queryRole: NullableEventRole = null;
  export let open: boolean = false;
  let flag: string;
  let flagInner: HTMLElement;
  let alertMessage: string | null;
  let alertColor: string | null;
  let keycloak: KeycloakInterface | undefined;
  let submissionDisabled: boolean;
  $: submissionDisabled = challenge?.solves?.length > 0;
  const renderers = {
    code: Code,
    codespan: CodeSpan,
  };

  KeycloakStore.subscribe((value) => (keycloak = value.keycloak));

  export function show(challengeToShow: ActiveChallenge) {
    challenge = challengeToShow;
    // reset some values on show
    alertMessage = null;
    flag = '';
    open = true;
  }

  export function hide() {
    open = false;
  }

  export function toggle() {
    if (open) hide();
    else show(challenge);
  }

  async function submitFlag() {
    if (!flag) {
      setAlert('Flag not submitted: No Flag was supplied!', 'warning');
      return;
    }
    if (!team) {
      setAlert('Flag not submitted: Could not determine your team!', 'danger');
      return;
    }
    let response;
    try {
      response = await SubmitFlag({
        flag,
        team,
        challenge,
        submitter: keycloak?.userEmail,
        queryOptions: { queryRole },
      });
    } catch (err) {
      if (err && err[0]?.message) {
        const message = err[0].message;
        if (message.startsWith('Uniqueness violation')) setAlert(`Flag already submitted: '${flag}'`, 'warning');
        else setAlert(`Failed to submit flag '${flag}': ${message}`, 'warning');
        return; // return early
      } else {
        setAlert(
          `Something went wrong submitting flag '${flag}', please sent a screenshot of browser console to staff`,
          'danger',
        );
        throw err;
      }
    }

    if (response?.length > 0) {
      setAlert('Correct!', 'success');
    } else {
      setAlert(`Flag is incorrect: '${flag}'`, 'danger');
    }
  }

  function setAlert(message: string, color: Color) {
    alertMessage = message;
    alertColor = color;
  }

  function onOpen() {
    flagInner.focus();
  }
</script>

<Modal on:open={onOpen} isOpen={open} {toggle}>
  <div class="modal-header">
    <h5 class="modal-title w-100">
      <div class="d-flex flex-row justify-content-between">
        <div class="d-flex flex-column m-2">
          {challenge.challenge.name}
          <br />
          <small>
            Designed By: {challenge.challenge.designer}
          </small>
        </div>
        <div class="d-flex flex-column m-2">
          Points: {challenge.points}
        </div>
      </div>
    </h5>
  </div>
  <ModalBody>
    <SvelteMarkdown source={challenge.challenge.description} {renderers} />
    {#if challenge.files.length > 0}
      {#each challenge.files as file}
        <ChallengeFileDownload {file} />
      {/each}
    {/if}
  </ModalBody>
  <div class="d-flex flex-column m-3">
    <div class="d-flex flex-row justify-content-end">
      <InputGroup>
        <Input
          on:keyup={(e) => {
            if (e.code === 'Enter' || e.code === 'NumpadEnter') submitFlag();
          }}
          bind:inner={flagInner}
          bind:value={flag}
          bind:disabled={submissionDisabled}
          placeholder={submissionDisabled ? 'Challenge Solved!' : 'ctf{flag}'}
        />
        <Button disabled={submissionDisabled} on:click={submitFlag} color="primary">Submit Flag</Button>
      </InputGroup>
    </div>
    <div class="alertDiv mt-3">
      <Alert color={alertColor} isOpen={!!alertMessage} fade={true}>
        {alertMessage}
      </Alert>
    </div>
  </div>
</Modal>
